/*
 * Copyright (C) 2003 Kristoffer Vinther
 * This code is based largely on code developed by
 *
 *   Li Xiao, Xiaodong Zhang, and Stefan A. Kubricht
 *
 * available at
 * http://www.jea.acm.org/2000/XiaoMemory/
 */

#include <iterator>
#include "../bench.h"

struct sorter
{
	typedef minxp::false_type inplace;
	typedef std::random_access_iterator_tag out_iterator_category;
	template<class RanIt>
	static inline void sort(RanIt a, RanIt ae, RanIt b)
	{
	typedef typename std::iterator_traits<RanIt>::value_type T;
	RanIt source,target,xchg;
	size_t n,cachesize,pagesize;
	size_t i,j1,j2,jj2,jj3,k,kk,m,w,it=0,min;

	n = ae-a;
#ifdef _MIPS_ISA
	cachesize = 1024*1024/sizeof(T)/2;
	pagesize = 8192;
#else // _MIPS_ISA
	cachesize = 256*1024/sizeof(T)/2;
	pagesize = 4096;
#endif // _MIPS_ISA



	min = cachesize;
	if( n < min )
		min = n;
  kk=0;
  do {
    jj2=kk;
    jj3=jj2+min;
    for (i=jj2; i<jj3; i=i+4)
      for (j1=i; j1<i+3;j1++)
	for (j2=j1+1; j2<i+4; j2++) {
	  if (a[j2]<a[j1]) {
	    T xt=a[j1];
	    a[j1]=a[j2];
	    a[j2]=xt;
	  }
	}

    source=a;
    target=b;
    w=2;
    m=min/(2*w);
    while (2*w<min) {
      k=kk;
      w=w*2;
      m=m/2;
      j2=kk;
      for (i=0;i<m;i++){
	j1=j2;
	j2=j2+w;
	jj2=j2;
	jj3=j2+w;
	while ((j1<jj2)&&(j2<jj3)) {
	  if (source[j1]<source[j2])
	    target[k++]=source[j1++];
	  else
	    target[k++]=source[j2++];
	}
	if (j1==jj2) {
	  while (j2<jj3)
	    target[k++]=source[j2++];
	}
	if (j2==jj3) {
	  while (j1<jj2)
	    target[k++]=source[j1++];
	}
      }
      xchg=source;
      source=target;
      target=xchg;      
    }

    kk=kk+min;
    it++;
  }while(it<n/cachesize);

  // second phase: base mergesort

  m=n/(2*w);
  while (2*w<n) {
    k=0;
    w=w*2;
    m=m/2;
    j2=0;
    for (i=0;i<m;i++) {
      j1=j2;
      j2=j2+w;
      jj2=j2;
      jj3=j2+w;
      while ((j1<jj2)&&(j2<jj3)) {
	if (source[j1]<source[j2])
	  target[k++]=source[j1++];
	else
	  target[k++]=source[j2++];
      }
      if (j1==jj2) {
	while (j2<jj3)
	  target[k++]=source[j2++];
      }
      if (j2==jj3) {
	while (j1<jj2)
	  target[k++]=source[j1++];
      }
    }
    xchg=source;
    source=target;
    target=xchg;
  }
	}
	static const char* name;
};
const char* sorter::name = "msort-c";

int main(int argc, char *argv[])
{
	return bench_this<sorter>(argv,argc+argv);
}
