/*
 * Copyright (C) 2003 Kristoffer Vinther
 * This code is based largely on code developed by
 *
 *   Li Xiao, Xiaodong Zhang, and Stefan A. Kubricht
 *
 * available at
 * http://www.jea.acm.org/2000/XiaoMemory/
 */


#include <iterator>
#include "../bench.h"

struct sorter
{
template<class T>
struct PQUEUE {
  T c;
  int index0;
  int index;
};
	typedef minxp::false_type inplace;
	typedef std::random_access_iterator_tag out_iterator_category;
	template<class RanIt>
	static inline void sort(RanIt a, RanIt ae, RanIt b)
	{
	typedef typename std::iterator_traits<RanIt>::value_type T;
	typedef PQUEUE<T> QUEUE;

	QUEUE *queue, tmp;
	RanIt source,target,xchg;
	size_t n,cachesize,pagesize;
	size_t i,j1,j2,jj2,jj3,k,kk,nn,m,w,it=0,min,change;
	size_t current,parent, childl, childr;

	n = ae-a;
#ifdef _MIPS_ISA
	cachesize = 1024*1024/sizeof(T)/2;
	pagesize = 8192;
#else // _MIPS_ISA
	cachesize = 256*1024/sizeof(T)/2;
	pagesize = 4096;
#endif // _MIPS_ISA
	nn = n/cachesize;
	queue = new QUEUE[nn];

	min = cachesize;
	if( n < min )
		min = n;
  kk=0;
  do {
    jj2=kk;
    jj3=jj2+min;
    for (i=jj2; i<jj3; i=i+4)
      for (j1=i; j1<i+3;j1++)
	for (j2=j1+1; j2<i+4; j2++) {
	  if (a[j2]<a[j1]) {
	    T xt=a[j1];
	    a[j1]=a[j2];
	    a[j2]=xt;
	  }
	}

    source=a;
    target=b;
    w=2;
    m=min/(2*w);
    while (2*w<min) {
      k=kk;
      w=w*2;
      m=m/2;
      j2=kk;
      for (i=0;i<m;i++){
	j1=j2;
	j2=j2+w;
	jj2=j2;
	jj3=j2+w;
	while ((j1<jj2)&&(j2<jj3)) {
	  if (source[j1]<source[j2])
	    target[k++]=source[j1++];
	  else
	    target[k++]=source[j2++];
	}
	if (j1==jj2) {
	  while (j2<jj3)
	    target[k++]=source[j2++];
	}
	if (j2==jj3) {
	  while (j1<jj2)
	    target[k++]=source[j1++];
	}
      }
      xchg=source;
      source=target;
      target=xchg;
    }
    kk=kk+min;
    it++;
  }while(it<nn);

  if((2*w==n)&&(target==a))
    for (i=0; i<n; i++)
      a[i] = b[i];

  // second phase: multi-mergesort

  if(2*w<n) {
    if(target==b)
      for (i=0; i<n; i++)
	b[i] = a[i];

    for (i=0;i<nn;i++)
      queue[i].index=i*cachesize;

    // build a priority queue

    queue[0].c=b[0];
    for (i=1; i<nn;i++) {
      queue[i].c=b[queue[i].index];
      parent=i;
      while(parent>0) {
	current=parent;
	parent=(parent-1)/2;
	if(queue[current].c<queue[parent].c) {
	  tmp=queue[parent];
	  queue[parent]=queue[current];
	  queue[current]=tmp;
	}
      }
    }

    // remove-min, add new element and  keep heap

    k=0;
    while(k<n) {
      a[k]=queue[0].c;
      k++;
      queue[0].index++;
      if(queue[0].index%cachesize==0)
		  queue[0].c=std::numeric_limits<T>::max();
      else
	queue[0].c=b[queue[0].index];
      current=0;
      change=1;
      while(change==1) {
	change=0;
	childl=2*current+1;
	if (childl>=nn) break;
	childr=childl+1;
	min=childl;
	if ((queue[childr].c<queue[childl].c)&&(childr<nn))
	  min=childr;
	if (queue[min].c<queue[current].c) {
	  tmp=queue[current];
	  queue[current]=queue[min];
	  queue[min]=tmp;
	  current=min;
	  change=1;
	}
      }
    }
  }   

	}
	static const char* name;
};
const char* sorter::name = "msort-m";

int main(int argc, char *argv[])
{
	return bench_this<sorter>(argv,argc+argv);
}
