
#include "minxp/array.h"
#include "../bench.h"
#include <iterator>
#include <stdlib.h>

template<class T>
int qsort_comp(const void* a, const void* b)
{
	if( *(T*)b < *(T*)a )
		return 1;
	else if( *(T*)a < *(T*)b )
		return -1;
	else
		return 0;
}

struct sorter
{
	typedef minxp::true_type inplace;
	template<class RanIt>
	static inline void sort(RanIt b, RanIt e)
	{
		int (*compare)(const void *, const void *) = qsort_comp<typename std::iterator_traits<RanIt>::value_type>;
		qsort(&(*b), static_cast<size_t>(e-b), sizeof(typename std::iterator_traits<RanIt>::value_type), compare);
	}
	static const char* name;
};
const char* sorter::name = "qsort";

int main(int argc, char *argv[])
{
	return bench_this<sorter>(argv,argc+argv);
}
