<?xml version="1.0" encoding="UTF-8"?>
<stylesheet version="1.0" xmlns="http://www.w3.org/1999/XSL/Transform">
	<output method="text" omit-xml-declaration="yes" version="1.0" encoding="us-ascii" indent="no"/>

	<key name="algId" match="run" use="algorithm"/>
	<template match="benchmark">
		<text># Benchmark run stated </text><value-of select="./@date"/><text> on </text><value-of select="./@host"/><text> running </text><value-of select="./@os"/><text> </text><value-of select="./@version"/><text>&#10;</text>
		<text># </text><value-of select="./@host"/><text>&#10;</text>
		<text># (Algorithm Size Wallclocktime Pos.Err. Neg.Err. Pagefaults Pos.Err. Neg.Err. L1 misses Pos.Err. Neg.Err. L2 misses Pos.Err. Neg.Err. TLB misses Pos.Err. Neg.Err. Branch misspred. Pos.Err. Neg.Err. Instruction-count Pos.Err. Neg.Err. Comparisons Moves)</text><text>&#10;</text>
		<text>#&#10;</text>
		
		<for-each select="run[generate-id()=generate-id(key('algId',algorithm))][@execstatus=0]">
			<sort select="algorithm" order="ascending"/>
			<sort select="size" data-type="number" order="ascending"/>
			<call-template name="runs">
				<with-param name="alg-match" select="algorithm"/>
			</call-template>
<!-- index break -->
<text>

</text>
		</for-each>
		<text># Errors:</text><text>&#10;</text>
		<apply-templates select="run/error"/>
 	</template>
 	
 	<template name="runs">
		<param name="alg-match"/>
		<apply-templates select="/benchmark/run[algorithm=$alg-match]"/>
 	</template>

	<template match="run">
		<value-of select="algorithm"/><text> </text><value-of select="size"/><text> </text><value-of select="time"/><text> </text><value-of select="time_err[@dir='minus']"/><text> </text><value-of select="time_err[@dir='plus']"/><text> </text><value-of select="pagefaults"/><text> </text><value-of select="pagefaults_err[@dir='plus']"/><text> </text><value-of select="pagefaults_err[@dir='minus']"/><text> </text><value-of select="l1misses"/><text> </text><value-of select="l1misses_err[@dir='plus']"/><text> </text><value-of select="l1misses_err[@dir='minus']"/><text> </text><value-of select="l2misses"/><text> </text><value-of select="l2misses_err[@dir='plus']"/><text> </text><value-of select="l2misses_err[@dir='minus']"/><text> </text><value-of select="tlbmisses"/><text> </text><value-of select="tlbmisses_err[@dir='plus']"/><text> </text><value-of select="tlbmisses_err[@dir='minus']"/><text> </text><value-of select="branch-misspredict"/><text> </text><value-of select="branch-misspredict_err[@dir='plus']"/><text> </text><value-of select="branch-misspredict_err[@dir='minus']"/><text> </text><value-of select="instruction-count"/><text> </text><value-of select="instruction-count_err[@dir='plus']"/><text> </text><value-of select="instruction-count_err[@dir='minus']"/><text> </text><value-of select="comparisons"/><text> </text><value-of select="moves"/><text>&#10;</text>
	</template>
	
	<template match="run/error">
					<text>#   Text:</text><value-of select="normalize-space(../error)"/><text>&#10;</text>
					<text>#   Command line:</text><value-of select="normalize-space(../@commandline)"/><text>&#10;</text>
					<text>#   Host:</text><value-of select="../../@host"/><text>&#10;</text>
 	</template>

</stylesheet>
